package com.zhongzheng.modules.activity.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.activity.bo.ActivityGradePrivilegeCouresAddBo;
import com.zhongzheng.modules.activity.bo.ActivityGradePrivilegeCouresQueryBo;
import com.zhongzheng.modules.activity.bo.ActivityGradePrivilegeCouresEditBo;
import com.zhongzheng.modules.activity.domain.ActivityGradePrivilegeCoures;
import com.zhongzheng.modules.activity.mapper.ActivityGradePrivilegeCouresMapper;
import com.zhongzheng.modules.activity.vo.ActivityGradePrivilegeCouresVo;
import com.zhongzheng.modules.activity.service.IActivityGradePrivilegeCouresService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 积分关联特权的范围课程Service业务层处理
 *
 * @author change
 * @date 2021-05-20
 */
@Service
public class ActivityGradePrivilegeCouresServiceImpl extends ServiceImpl<ActivityGradePrivilegeCouresMapper, ActivityGradePrivilegeCoures> implements IActivityGradePrivilegeCouresService {

    @Override
    public ActivityGradePrivilegeCouresVo queryById(Long privilegeId){
        ActivityGradePrivilegeCoures db = this.baseMapper.selectById(privilegeId);
        return BeanUtil.toBean(db, ActivityGradePrivilegeCouresVo.class);
    }

    @Override
    public List<ActivityGradePrivilegeCouresVo> queryList(ActivityGradePrivilegeCouresQueryBo bo) {
        LambdaQueryWrapper<ActivityGradePrivilegeCoures> lqw = Wrappers.lambdaQuery();
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ActivityGradePrivilegeCouresVo> entity2Vo(Collection<ActivityGradePrivilegeCoures> collection) {
        List<ActivityGradePrivilegeCouresVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ActivityGradePrivilegeCouresVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ActivityGradePrivilegeCoures> page = (Page<ActivityGradePrivilegeCoures>)collection;
            Page<ActivityGradePrivilegeCouresVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ActivityGradePrivilegeCouresAddBo bo) {
        ActivityGradePrivilegeCoures add = BeanUtil.toBean(bo, ActivityGradePrivilegeCoures.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ActivityGradePrivilegeCouresEditBo bo) {
        ActivityGradePrivilegeCoures update = BeanUtil.toBean(bo, ActivityGradePrivilegeCoures.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ActivityGradePrivilegeCoures entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
